/*

transmit the input keys via io module to the console application
and also call the process function on received characters

*/

static inline void emu_write_char(emu_t *e, emu_char_t c)
{
	if (c < 128)
		;
#if CFG_EMULATION_ASCII_BORDERS
	/* translate borders (IBM PC codepage 437) */
	else if (c == 179 || c == 186)
		c = '|';
	else if (c == 196 || c == 205)
		c = '-';
	else if (180 <= c && c <= 218)
		c = '+';
#endif
//	else
//		log_printf(2, "non ascii:'%c' %d", c, c);
	if (e->need_wrap) {
		emu_cr(e);
		emu_lf(e);
	}
	buf_rw_from_cursor(e->buf);
	buf_write_char(e->buf, c);
	if (e->bs->cursor_x == e->bs->w - 1) {
		e->need_wrap = e->decawm;
	} else {
		buf_cursor_right(e->buf);
		buf_update(e->buf, e->bs->cursor_x - 1, e->bs->cursor_y,  e->bs->cursor_x, e->bs->cursor_y);
	}
}

static void emu_respond_string(emu_t *e, const char *p)
{
	while (*p) {
		io_got_user_input(e->io, *p);
		p++;
	}
}

void emu_dsp_char(void *emu, emu_char_t c)
{
	emu_t *e = emu;
	
	io_got_user_input(e->io, c);
}

void emu_io_char(void *emu, emu_char_t c)
{
	emu_t *e = emu;
	
	if (e->es == ES_NORMAL && c >= 32 && c != DEL && c != CSI) {
		emu_write_char(e, c);
	}
	emu_process(e, c);
}

void emu_dsp_ctrl(void *emu, ctrl_t ctrl)
{
	emu_t *e = emu;
	
	io_control(e->io, ctrl);
}

