#define _XOPEN_SOURCE
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <assert.h>
#include <unistd.h>
#include "lib.h"
#include "../io_common.c"
#include "global.h"

#include DISPLAY


io_instance_t *io_create(void *emu)
{
	io_instance_t *i;
	pid_t pid;

	i = malloc(sizeof(io_instance_t));

	i->master = posix_openpt(O_RDWR);
	assert(i->master >= 0);

	if (grantpt(i->master) != 0) {
		fprintf(stderr, "Couldn't grant permissions on pty (%d)\n", i->master);
		abort();
	}
	assert(unlockpt(i->master) == 0);

	printf("Opening: %s\n", ptsname(i->master));
	i->slave=open(ptsname(i->master), O_RDWR);
	assert(i->slave >= 0);

	vterm_open_slave(i->slave);

	i->emu = emu;
	display_watch(i->master, 1, io_got_output, i);
	return i;
}

void io_destroy(io_instance_t *i)
{
	vterm_close_slave(i->slave);
	close(i->master);
	close(i->slave);
	free(i);
}

void io_control(io_instance_t *i, ctrl_t ctrl) {
	switch(ctrl) {
		case ctrl_hup:
			break;
		case ctrl_term:
			break;
		case ctrl_resize:
			break;
	}
}
