#ifndef io_pty_h
#define io_pty_h

#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#define HAVE_IO
#include "io/interface.h"
#include "global.h"


typedef struct io_instance_s {
	int master, slave;
	void *emu;
	pid_t pid;
} io_instance_t;

/* Cerate a new IO instance */
io_instance_t *io_create(void *emu);

/* Destroy an IO instance */
void io_destroy(io_instance_t *io);

/* We got user input to be submitted to the process */
static inline void io_got_user_input(io_instance_t *io, unsigned char data)
{
	write(io->master, &data, 1);
}

/* Set the shell to run */
void io_set_shell(char *shell_, char *shell_args_[]);

void io_control(io_instance_t *i, ctrl_t ctrl);

static inline int io_get_master(io_instance_t *io)
{
	return io->master;
}

#ifndef CFG_IO_DEFAULT_SHELL
	#define CFG_IO_DEFAULT_SHELL "/bin/sh"
#endif

#endif
