#include <stdlib.h>
#include <stdio.h>
#include <libgen.h>
#include <string.h>
#include "Conf/global.h"

#include DISPLAY
#include IO

#define optarg_next (argv[++n])

FILE *log_file = NULL;
int verbose = 0;

/* Parse command line arguments */
void process_arg(int argc, char *argv[])
{
	int n, shell_from = -1;
	char *optarg;

	for(n = 1; n < argc; n++) {
		optarg = argv[n];

		if (*optarg != '-') {
			shell_from = n;
			break;
		}
		/* Strip at most two - characters */
		if (*optarg == '-') optarg++;
		if (*optarg == '-') optarg++;
		switch(*optarg) {
			case 'h':
				printf("%s - the VGA Linux terminal emulator\n", basename(argv[0]));
				printf("Usage: %s [-t title]\n", basename(argv[0]));
				printf(" -t          override title\n");
				exit(0);
				break;
			case 't':
				display_set_title(optarg_next);
				break;
			case 'v':
				verbose++;
				break;
			case 'l':
				n++;
				log_file = fopen(argv[n] == NULL ? "/tmp/vterm.log" : argv[n], "w");
				break;
			default:
				printf("Unknown argument: %s\n", argv[n]);
				abort();
		}
	}
	if (shell_from >= 0) {
		io_set_shell(argv[shell_from], &(argv[shell_from]));
	}
}

int main(int argc, char *argv[])
{
	display_set_title(basename(argv[0]));
	process_arg(argc, argv);
	display_start();			
	return 0;
}

